// DetailBoardEditDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardEditDlg.h"
#include "afxdialogex.h"


// CDetailBoardEditDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardEditDlg, CDialog)

//CDetailBoardEditDlg::CDetailBoardEditDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardEditDlg::IDD, pParent)
//{
//
//}

CDetailBoardEditDlg::CDetailBoardEditDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardEditDlg::IDD, NULL)
	, board_(board)
{

}

CDetailBoardEditDlg::~CDetailBoardEditDlg()
{
}

void CDetailBoardEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_SHORTCUT, m_xcCmbShortcut);
	DDX_Control(pDX, IDC_CHECK_WRITE, m_xcCheckWrite);
	DDX_Control(pDX, IDC_CHECK_CLOSE, m_xcCheckClose);
	DDX_Control(pDX, IDC_CHECK_FOCUS, m_xcCheckFocus);
}

void CDetailBoardEditDlg::InitControls()
{
	switch (board_.shortcut)
	{
	default:
	case sl::BoardConfig::EDIT_SHORTCUT_SHIFT_ENTER:	m_xcCmbShortcut.SetCurSel(0); break;
	case sl::BoardConfig::EDIT_SHORTCUT_CTRL_ENTER:		m_xcCmbShortcut.SetCurSel(1); break;
	case sl::BoardConfig::EDIT_SHORTCUT_ALT_ENTER:		m_xcCmbShortcut.SetCurSel(2); break;
	}

	m_xcCheckWrite.SetCheck(board_.write ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckClose.SetCheck(board_.close ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckFocus.SetCheck(board_.focus ? BST_CHECKED : BST_UNCHECKED);
}



BEGIN_MESSAGE_MAP(CDetailBoardEditDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardEditDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardEditDlg bZ[W nh[


BOOL CDetailBoardEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcCmbShortcut.AddString(L"Shift + Enter");
	m_xcCmbShortcut.AddString(L"Ctrl + Enter");
	m_xcCmbShortcut.AddString(L"Alt + Enter");

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardEditDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardEditDlg::OnDestroy()
{
	CDialog::OnDestroy();

	switch (m_xcCmbShortcut.GetCurSel())
	{
	default:
	case 0:	board_.shortcut = sl::BoardConfig::EDIT_SHORTCUT_SHIFT_ENTER; break;
	case 1:	board_.shortcut = sl::BoardConfig::EDIT_SHORTCUT_CTRL_ENTER; break;
	case 2:	board_.shortcut = sl::BoardConfig::EDIT_SHORTCUT_ALT_ENTER; break;
	}

	board_.write = m_xcCheckWrite.GetCheck() == BST_CHECKED;
	board_.close = m_xcCheckClose.GetCheck() == BST_CHECKED;
	board_.focus = m_xcCheckFocus.GetCheck() == BST_CHECKED;
}


void CDetailBoardEditDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.shortcut = tmp.shortcut;
	board_.write = tmp.write;
	board_.close = tmp.close;
	board_.focus = tmp.focus;

	InitControls();
}
