// DetailBoardNetworkDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardNetworkDlg.h"
#include "afxdialogex.h"


// CDetailBoardNetworkDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardNetworkDlg, CDialog)

//CDetailBoardNetworkDlg::CDetailBoardNetworkDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardNetworkDlg::IDD, pParent)
//{
//
//}

CDetailBoardNetworkDlg::CDetailBoardNetworkDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardNetworkDlg::IDD, NULL)
	, board_(board)
{

}

CDetailBoardNetworkDlg::~CDetailBoardNetworkDlg()
{
}

void CDetailBoardNetworkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_USERAGENT, m_xcEditUserAgent);
	DDX_Control(pDX, IDC_SPIN_TIMEOUT, m_xcSpinTimeout);
	DDX_Control(pDX, IDC_CHECK_PROXY_GET_ENABLE, m_xcCheckProxyGetEnable);
	DDX_Control(pDX, IDC_EDIT_PROXY_GET_NAME, m_xcEditProxyGetName);
	DDX_Control(pDX, IDC_CHECK_PROXY_POST_ENABLE, m_xcCheckProxyPostEnable);
	DDX_Control(pDX, IDC_EDIT_PROXY_POST_NAME, m_xcEditProxyPostName);
	DDX_Control(pDX, IDC_EDIT_PROXY_WHITE, m_xcEditProxyWhite);
	DDX_Control(pDX, IDC_EDIT_PROXY_BLACK, m_xcEditProxyBlack);
}

void CDetailBoardNetworkDlg::InitControls()
{
	m_xcEditUserAgent.SetWindowText(board_.userAgent.c_str());
	m_xcSpinTimeout.SetPos32(board_.timeout);
	m_xcCheckProxyGetEnable.SetCheck(board_.proxy.get.enable ? BST_CHECKED : BST_UNCHECKED);
	m_xcEditProxyGetName.SetWindowText(board_.proxy.get.name.c_str());
	m_xcCheckProxyPostEnable.SetCheck(board_.proxy.post.enable ? BST_CHECKED : BST_UNCHECKED);
	m_xcEditProxyPostName.SetWindowText(board_.proxy.post.name.c_str());
	m_xcEditProxyWhite.SetWindowText(board_.proxy.white.c_str());
	m_xcEditProxyBlack.SetWindowText(board_.proxy.black.c_str());

	EnableControls();
}

void CDetailBoardNetworkDlg::EnableControls()
{
	BOOL get = board_.proxy.get.enable ? TRUE : FALSE;
	BOOL post = board_.proxy.post.enable ? TRUE : FALSE;

	m_xcEditProxyGetName.EnableWindow(get);
	m_xcEditProxyPostName.EnableWindow(post);
	m_xcEditProxyWhite.EnableWindow(get || post);
	m_xcEditProxyBlack.EnableWindow(get || post);
}


BEGIN_MESSAGE_MAP(CDetailBoardNetworkDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardNetworkDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_PROXY_GET_ENABLE, &CDetailBoardNetworkDlg::OnBnClickedCheckProxyGetEnable)
	ON_BN_CLICKED(IDC_CHECK_PROXY_POST_ENABLE, &CDetailBoardNetworkDlg::OnBnClickedCheckProxyPostEnable)
END_MESSAGE_MAP()


// CDetailBoardNetworkDlg bZ[W nh[


BOOL CDetailBoardNetworkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinTimeout.SetRange32(0, 60000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardNetworkDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardNetworkDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// userAgent
	CString userAgent;
	m_xcEditUserAgent.GetWindowText(userAgent);
	board_.userAgent = std::wstring(userAgent);

	// timeout
	board_.timeout = m_xcSpinTimeout.GetPos32();

	// proxy.get
	board_.proxy.get.enable = m_xcCheckProxyGetEnable.GetCheck() == BST_CHECKED;

	CString get;
	m_xcEditProxyGetName.GetWindowText(get);
	board_.proxy.get.name = std::wstring(get);

	// proxy.post
	board_.proxy.post.enable = m_xcCheckProxyPostEnable.GetCheck() == BST_CHECKED;

	CString post;
	m_xcEditProxyPostName.GetWindowText(post);
	board_.proxy.post.name = std::wstring(post);

	// proxy.white
	CString white;
	m_xcEditProxyWhite.GetWindowText(white);
	board_.proxy.white = std::wstring(white);

	// proxy.black
	CString black;
	m_xcEditProxyBlack.GetWindowText(black);
	board_.proxy.black = std::wstring(black);
}


void CDetailBoardNetworkDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.userAgent = tmp.userAgent;
	board_.timeout = tmp.timeout;
	board_.proxy = tmp.proxy;

	InitControls();
}


void CDetailBoardNetworkDlg::OnBnClickedCheckProxyGetEnable()
{
	board_.proxy.get.enable = m_xcCheckProxyGetEnable.GetCheck() == BST_CHECKED;

	EnableControls();
}

void CDetailBoardNetworkDlg::OnBnClickedCheckProxyPostEnable()
{
	board_.proxy.post.enable = m_xcCheckProxyPostEnable.GetCheck() == BST_CHECKED;

	EnableControls();
}

