// DetailBoardResDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardResDlg.h"
#include "afxdialogex.h"


// CDetailBoardResDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardResDlg, CDialog)

//CDetailBoardResDlg::CDetailBoardResDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardResDlg::IDD, pParent)
//{
//
//}

CDetailBoardResDlg::CDetailBoardResDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardResDlg::IDD, NULL)
	, board_(board)
{

}

CDetailBoardResDlg::~CDetailBoardResDlg()
{
}

void CDetailBoardResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPIN_RES, m_xcSpinRes);
	DDX_Control(pDX, IDC_SPIN_DELAY, m_xcSpinDelay);
	DDX_Control(pDX, IDC_CMB_POSITION, m_xcCmbPosition);
	DDX_Control(pDX, IDC_CHECK_UNDER, m_xcCheckUnder);
	DDX_Control(pDX, IDC_CHECK_ALIGN, m_xcCheckAlign);
	DDX_Control(pDX, IDC_CHECK_ORDER, m_xcCheckOrder);
	DDX_Control(pDX, IDC_CHECK_SCROLL, m_xcCheckScroll);
}

void CDetailBoardResDlg::InitControls()
{
	m_xcSpinRes.SetPos32(board_.res);
	m_xcSpinDelay.SetPos32(board_.delay);

	switch (board_.position)
	{
	case sl::BoardConfig::POPUP_POSITION_CENTER:	m_xcCmbPosition.SetCurSel(0); break;
	case sl::BoardConfig::POPUP_POSITION_LEFT:		m_xcCmbPosition.SetCurSel(1); break;
	case sl::BoardConfig::POPUP_POSITION_RIGHT:		m_xcCmbPosition.SetCurSel(2); break;
	case sl::BoardConfig::POPUP_POSITION_BOTH:		m_xcCmbPosition.SetCurSel(3); break;
	default: m_xcCmbPosition.SetCurSel(0); break;
	}

	m_xcCheckUnder.SetCheck(board_.under ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckAlign.SetCheck(board_.align ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckOrder.SetCheck(board_.order ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckScroll.SetCheck(board_.scroll ? BST_CHECKED : BST_UNCHECKED);
}



BEGIN_MESSAGE_MAP(CDetailBoardResDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardResDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardResDlg bZ[W nh[


BOOL CDetailBoardResDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinRes.SetRange32(1, 100);
	m_xcSpinDelay.SetRange32(0, 1000);

	m_xcCmbPosition.AddString(L"J[\ɕ\");
	m_xcCmbPosition.AddString(L"J[\ɕ\");
	m_xcCmbPosition.AddString(L"J[\Eɕ\");
	m_xcCmbPosition.AddString(L"EBhEŃJ[\E؂ւ");

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardResDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardResDlg::OnDestroy()
{
	CDialog::OnDestroy();

	board_.res = m_xcSpinRes.GetPos32();
	board_.delay = m_xcSpinDelay.GetPos32();

	switch (m_xcCmbPosition.GetCurSel())
	{
	default:
	case 0:	board_.position = sl::BoardConfig::POPUP_POSITION_CENTER; break;
	case 1:	board_.position = sl::BoardConfig::POPUP_POSITION_LEFT; break;
	case 2:	board_.position = sl::BoardConfig::POPUP_POSITION_RIGHT; break;
	case 3:	board_.position = sl::BoardConfig::POPUP_POSITION_BOTH; break;
	}

	board_.under = m_xcCheckUnder.GetCheck() == BST_CHECKED;
	board_.align = m_xcCheckAlign.GetCheck() == BST_CHECKED;
	board_.order = m_xcCheckOrder.GetCheck() == BST_CHECKED;
	board_.scroll = m_xcCheckScroll.GetCheck() == BST_CHECKED;
}


void CDetailBoardResDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.res = tmp.res;
	board_.delay = tmp.delay;
	board_.position = tmp.position;
	board_.under = tmp.under;
	board_.align = tmp.align;
	board_.order = tmp.order;
	board_.scroll = tmp.scroll;

	InitControls();
}
