// DetailTypeFLV3Dlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailTypeFLV3Dlg.h"
#include "afxdialogex.h"


// CDetailTypeFLV3Dlg _CAO

IMPLEMENT_DYNAMIC(CDetailTypeFLV3Dlg, CDialog)

//CDetailTypeFLV3Dlg::CDetailTypeFLV3Dlg(CWnd* pParent /*=NULL*/)
//	: CDialog(IDD_DETAIL_TYPE_FLV1, pParent)
//{
//
//}

CDetailTypeFLV3Dlg::CDetailTypeFLV3Dlg(sl::TypeConfig::FLV& flv)
	: CDialog(CDetailTypeFLV3Dlg::IDD, NULL)
	, flv_(flv)
{

}

CDetailTypeFLV3Dlg::~CDetailTypeFLV3Dlg()
{
}

void CDetailTypeFLV3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_DELAY, m_xcCheckDelay);
	DDX_Control(pDX, IDC_EDIT_LIMIT, m_xcEditLimit);
	DDX_Control(pDX, IDC_SPIN_LIMIT, m_xcSpinLimit);
	DDX_Control(pDX, IDC_EDIT_INTERVAL, m_xcEditInterval);
	DDX_Control(pDX, IDC_SPIN_INTERVAL, m_xcSpinInterval);
}

void CDetailTypeFLV3Dlg::InitControls()
{
	m_xcCheckDelay.SetCheck(flv_.delay ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinLimit.SetPos32(flv_.limit);
	m_xcSpinInterval.SetPos32(flv_.interval);

	BOOL enable = flv_.delay ? TRUE : FALSE;
	m_xcEditLimit.EnableWindow(enable);
	m_xcSpinLimit.EnableWindow(enable);
	m_xcEditInterval.EnableWindow(enable);
	m_xcSpinInterval.EnableWindow(enable);
}

BEGIN_MESSAGE_MAP(CDetailTypeFLV3Dlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailTypeFLV3Dlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_DELAY, &CDetailTypeFLV3Dlg::OnBnClickedCheckDelay)
END_MESSAGE_MAP()


// CDetailTypeFLV3Dlg bZ[W nh[


BOOL CDetailTypeFLV3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinLimit.SetRange32(0, 600000);
	m_xcSpinInterval.SetRange32(0, 600000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailTypeFLV3Dlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailTypeFLV3Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	flv_.delay = m_xcCheckDelay.GetCheck() == BST_CHECKED;
	flv_.limit = m_xcSpinLimit.GetPos32();
	flv_.interval = m_xcSpinInterval.GetPos32();
}


void CDetailTypeFLV3Dlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::TypeConfig::FLV();

	flv_.delay = tmp.delay;
	flv_.limit = tmp.limit;
	flv_.interval = tmp.interval;

	InitControls();
}


void CDetailTypeFLV3Dlg::OnBnClickedCheckDelay()
{
	flv_.delay = m_xcCheckDelay.GetCheck() == BST_CHECKED;

	BOOL enable = flv_.delay ? TRUE : FALSE;
	m_xcEditLimit.EnableWindow(enable);
	m_xcSpinLimit.EnableWindow(enable);
	m_xcEditInterval.EnableWindow(enable);
	m_xcSpinInterval.EnableWindow(enable);
}
