// DisplayResFormatDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DisplayResFormatDlg.h"
#include "afxdialogex.h"


// CDisplayResFormatDlg _CAO

IMPLEMENT_DYNAMIC(CDisplayResFormatDlg, CDialog)

//CDisplayResFormatDlg::CDisplayResFormatDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDisplayResFormatDlg::IDD, pParent)
//{
//
//}

CDisplayResFormatDlg::CDisplayResFormatDlg(sl::ResConfig& res, CResSampleView& sample)
	: CDialog(CDisplayResFormatDlg::IDD, NULL)
	, res_(res)
	, m_xcSample(sample)
{

}

CDisplayResFormatDlg::~CDisplayResFormatDlg()
{
}

void CDisplayResFormatDlg::InitControls()
{
	if (res_.format.type < 0 || res_.format.type >= sl::ResConfig::FORMAT_COUNT)
	{
		res_.format.type = 0;
	}
	m_xcCmbFormat.SetCurSel(res_.format.type);

	m_xcBtnFont.SetFontIndirect(res_.format.font);
	m_xcBtnFont.Invalidate(FALSE);

	m_xcSpinSpace.SetPos32(res_.format.space);
	m_xcSpinWidth.SetPos32(res_.format.width);


	if (res_.format.punct < 0 || res_.format.punct >= sl::ResConfig::PUNCT_COUNT)
	{
		res_.format.punct = 0;
	}
	m_xcCmbPunct.SetCurSel(res_.format.punct);

	m_xcCheckSecond.SetCheck(res_.format.second ? BST_CHECKED : BST_UNCHECKED);

	m_xcSample.SetFontIndirect(res_.format.font);
}


void CDisplayResFormatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_FORMAT, m_xcCmbFormat);
	DDX_Control(pDX, IDC_BTN_FONT, m_xcBtnFont);
	DDX_Control(pDX, IDC_SPIN_SPACE, m_xcSpinSpace);
	DDX_Control(pDX, IDC_SPIN_WIDTH, m_xcSpinWidth);
	DDX_Control(pDX, IDC_CMB_PUNCT, m_xcCmbPunct);
	DDX_Control(pDX, IDC_CHECK_SECOND, m_xcCheckSecond);
}


BEGIN_MESSAGE_MAP(CDisplayResFormatDlg, CDialog)
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_CMB_FORMAT, &CDisplayResFormatDlg::OnCbnSelchangeCmbFormat)
	ON_BN_CLICKED(IDC_BTN_FONT, &CDisplayResFormatDlg::OnBnClickedBtnFont)
	ON_EN_CHANGE(IDC_EDIT_SPACE, &CDisplayResFormatDlg::OnEnChangeEditSpace)
	ON_EN_CHANGE(IDC_EDIT_WIDTH, &CDisplayResFormatDlg::OnEnChangeEditWidth)
	ON_CBN_SELCHANGE(IDC_CMB_PUNCT, &CDisplayResFormatDlg::OnCbnSelchangeCmbPunct)
	ON_BN_CLICKED(IDC_CHECK_SECOND, &CDisplayResFormatDlg::OnBnClickedCheckSecond)
END_MESSAGE_MAP()


// CDisplayResFormatDlg bZ[W nh[


BOOL CDisplayResFormatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcCmbFormat.InsertString(0, L"m[}");
	m_xcCmbFormat.InsertString(1, L"m[} (ftHĝ)");
	m_xcCmbFormat.InsertString(2, L"Vv");
	m_xcCmbFormat.InsertString(3, L"Vv (O\)");
	m_xcCmbFormat.InsertString(4, L"Vv (ftHĝ)");
	m_xcCmbFormat.InsertString(5, L"RpNg");

	m_xcSpinSpace.SetRange32(0, 100);
	m_xcSpinWidth.SetRange32(0, INT_MAX);

	m_xcCmbPunct.InsertString(0, L"Ȃ");
	m_xcCmbPunct.InsertString(1, L"Xy[X");
	m_xcCmbPunct.InsertString(2, L"R");
	
	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDisplayResFormatDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CDisplayResFormatDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh[ R[hǉ܂B
}



void CDisplayResFormatDlg::OnCbnSelchangeCmbFormat()
{
	res_.format.type = m_xcCmbFormat.GetCurSel();
	m_xcSample.SetFormatType(res_.format.type);
	m_xcSample.Invalidate(FALSE);
}

void CDisplayResFormatDlg::OnBnClickedBtnFont()
{
	LOGFONT lf = {};
	if (m_xcBtnFont.DoModal(lf))
	{
		res_.format.font = lf;
		m_xcSample.SetFontIndirect(lf);
		m_xcSample.Invalidate(FALSE);
	}
}

void CDisplayResFormatDlg::OnEnChangeEditSpace()
{
	if (!IsWindow(m_xcSpinSpace.GetSafeHwnd())) { return; }
	res_.format.space = m_xcSpinSpace.GetPos32();
	m_xcSample.SetFormatSpace(res_.format.space);
	m_xcSample.Invalidate(FALSE);
}

void CDisplayResFormatDlg::OnEnChangeEditWidth()
{
	if (!IsWindow(m_xcSpinWidth.GetSafeHwnd())) { return; }
	res_.format.width = m_xcSpinWidth.GetPos32();
	m_xcSample.SetFormatWidth(res_.format.width);
	m_xcSample.Invalidate(FALSE);
}

void CDisplayResFormatDlg::OnCbnSelchangeCmbPunct()
{
	res_.format.punct = m_xcCmbPunct.GetCurSel();
	m_xcSample.SetFormatPunct(res_.format.punct);
	m_xcSample.Invalidate(FALSE);
}

void CDisplayResFormatDlg::OnBnClickedCheckSecond()
{
	if (!IsWindow(m_xcCheckSecond.GetSafeHwnd())) { return; }
	res_.format.second = m_xcCheckSecond.GetCheck() == BST_CHECKED;
	m_xcSample.SetFormatSecond(res_.format.second);
	m_xcSample.Invalidate(FALSE);
}
