// FavoriteDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "FavoriteDlg.h"
#include "afxdialogex.h"


// CFavoriteDlg _CAO

IMPLEMENT_DYNAMIC(CFavoriteDlg, CDialog)

CFavoriteDlg::CFavoriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFavoriteDlg::IDD, pParent)
{

}

CFavoriteDlg::~CFavoriteDlg()
{
}

void CFavoriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_xcEditTitle);
	DDX_Control(pDX, IDC_EDIT_URL, m_xcEditURL);
}


BEGIN_MESSAGE_MAP(CFavoriteDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST, &CFavoriteDlg::OnLvnGetdispinfoList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CFavoriteDlg::OnLvnItemchangedList)
	ON_BN_CLICKED(IDC_BTN_ADD, &CFavoriteDlg::OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_DEL, &CFavoriteDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_UP, &CFavoriteDlg::OnBnClickedBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, &CFavoriteDlg::OnBnClickedBtnDown)
	ON_EN_CHANGE(IDC_EDIT_TITLE, &CFavoriteDlg::OnEnChangeEditTitle)
	ON_EN_CHANGE(IDC_EDIT_URL, &CFavoriteDlg::OnEnChangeEditUrl)
END_MESSAGE_MAP()

void CFavoriteDlg::EnableControls(BOOL enable)
{
	m_xcEditTitle.EnableWindow(enable);
	m_xcEditURL.EnableWindow(enable);
}

void CFavoriteDlg::SetControls(int index)
{
	if (links_.empty() || index < 0)
	{
		EnableControls(FALSE);
		//--------------------------------
		m_xcEditTitle.SetWindowText(L"");
		m_xcEditURL.SetWindowText(L"");
	}
	else if (index < static_cast<int>(links_.size()))
	{
		try {
			sl::Link link = links_.at(index);

			EnableControls(TRUE);
			//--------------------------------
			m_xcEditTitle.SetWindowText(link.title.c_str());
			m_xcEditURL.SetWindowText(link.url.c_str());
		}
		catch (std::exception const&) {}
	}
}

// CFavoriteDlg bZ[W nh[


BOOL CFavoriteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Xg
	m_xcList.SetExtendedStyle(m_xcList.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_INFOTIP|LVS_EX_DOUBLEBUFFER);

	m_xcList.InsertColumn(0, L"^Cg", LVCFMT_LEFT, 150);
	m_xcList.InsertColumn(1, L"URL", LVCFMT_LEFT, 280);

	m_xcList.SetItemCountEx(static_cast<int>(links_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcList.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcList.EnsureVisible(0, FALSE);
	SetControls(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CFavoriteDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB

	return CDialog::PreTranslateMessage(pMsg);
}


void CFavoriteDlg::OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (!pDispInfo) { return; }
	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		try {
			switch (pDispInfo->item.iSubItem)
			{
			case 0:
				{
					csLine = links_.at(i).title.c_str();
					break;
				}
			case 1:
				{
					csLine = links_.at(i).url.c_str();
					break;
				}
			}
		} catch (...) {}

		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}

void CFavoriteDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	SetControls(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));

	if (pResult) { *pResult = 0; }
}


void CFavoriteDlg::OnBnClickedBtnAdd()
{
	sl::Link link;
	links_.push_back(link);

	int count = static_cast<int>(links_.size());
	m_xcList.SetItemCountEx(count, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcList.SetItemState(count - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcList.EnsureVisible(count - 1, FALSE);
	SetControls(count - 1);
}


void CFavoriteDlg::OnBnClickedBtnDel()
{
	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)links_.size()) { return; }

	try {
		links_.erase(links_.begin() + i);
		int count = static_cast<int>(links_.size());
		m_xcList.SetItemCountEx(count, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if (count > i)
		{
			m_xcList.SetItemState(i, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcList.EnsureVisible(i, FALSE);
		}
		m_xcList.RedrawWindow();
	} catch (...) {}

	OnLvnItemchangedList(0, 0);
}


void CFavoriteDlg::OnBnClickedBtnUp()
{
	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)links_.size()) { return; }

	if (i <= 0) { return; }

	try {
		sl::Link x = links_.at(i - 1);
		links_.at(i - 1) = links_.at(i);
		links_.at(i) = x;

		m_xcList.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(i - 1, FALSE);

		m_xcList.RedrawWindow();
	} catch (...) {}
}


void CFavoriteDlg::OnBnClickedBtnDown()
{
	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)links_.size()) { return; }

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (i >= (int)(links_.size() - 1)) { return; }

	try {
		sl::Link x = links_.at(i + 1);
		links_.at(i + 1) = links_.at(i);
		links_.at(i) = x;

		m_xcList.SetItemState(i + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(i + 1, FALSE);

		m_xcList.RedrawWindow();
	} catch (...) {}
}


void CFavoriteDlg::OnEnChangeEditTitle()
{
	if (!IsWindow(m_xcList.GetSafeHwnd())) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)links_.size()) { return; }

	if (!IsWindow(m_xcEditTitle.GetSafeHwnd())) { return; }

	CString str;
	m_xcEditTitle.GetWindowText(str);

	links_.at(i).title = std::wstring(str);
	m_xcList.Update(i);
}


void CFavoriteDlg::OnEnChangeEditUrl()
{
	if (!IsWindow(m_xcList.GetSafeHwnd())) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)links_.size()) { return; }

	if (!IsWindow(m_xcEditURL.GetSafeHwnd())) { return; }

	CString str;
	m_xcEditURL.GetWindowText(str);

	links_.at(i).url = std::wstring(str);
	m_xcList.Update(i);
}


